<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'BySolutionValueProp',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    justifyContent: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
});
</script>

<template>
  <section
    :id="data.id"
    class="solution-value-prop"
    :class="{ 'light-background': data.light_background }"
  >
    <SlpContainer>
      <SlpRow class="resources-block-container">
        <SlpColumn v-if="justifyContent" :cols="2" />
        <SlpColumn
          :cols="9"
          class="resources-block__header"
          :data-aos="data.header_animation"
          :data-aos-duration="data.header_animation_duration"
        >
          <SlpTypography tag="h2" variant="heading3" class="slp-mt-32 slp-mb-64"
            >{{ data.title }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow>
        <SlpColumn v-if="justifyContent" :cols="2" />
        <SlpColumn>
          <SlpRow
            :style="{
              justifyContent: justifyContent ? 'flex-end' : 'flex-start',
            }"
          >
            <SlpColumn
              v-for="(card, index) in data.cards"
              :key="index"
              :cols="
                data.cards.length % 2 !== 0 &&
                index ===
                  (data.large_card_on_bottom ? data.cards.length - 1 : 0)
                  ? 12
                  : 6
              "
              :data-aos="data.cards_animation"
              :data-aos-duration="data.cards_animation_duration"
              size="md"
              class="resources-block__col"
            >
              <div class="resources-block">
                <div
                  class="resources-block__wrapper"
                  :class="{ 'light-background': data.light_background }"
                >
                  <div class="resources-block__content-top">
                    <div class="resources-block__category slp-flex">
                      <SlpIcon
                        v-if="card.icon"
                        :name="card.icon.name"
                        :alt="card.icon.alt"
                        :variant="card.icon.variant"
                        size="md"
                      />
                      <SlpTypography tag="p" variant="body2"
                        >{{ card.category }}
                      </SlpTypography>
                    </div>
                    <SlpTypography
                      tag="h3"
                      variant="heading4"
                      class="resources-block__title"
                      >{{ card.title }}
                    </SlpTypography>
                    <SlpTypography
                      tag="p"
                      variant="body2"
                      class="resources-block__description"
                      ><span v-html="card.description"></span>
                    </SlpTypography>
                    <SlpButton
                      v-if="card.href"
                      variant="tertiary"
                      class="learn-more"
                      :href="card.href"
                      :data-ga-name="card.data_ga_name ?? 'Learn more'"
                      :data-ga-location="card.data_ga_location ?? 'body'"
                      >{{ card.cta || 'Learn More' }}

                      <SlpIcon name="chevron-lg-right" variant="product" />
                    </SlpButton>
                    <SlpTypography
                      tag="p"
                      variant="body1"
                      class="resources-block__description"
                    >
                      <ul v-if="card.list" class="resources-block__list">
                        <li
                          v-for="feature in card.list"
                          :key="feature.text"
                          class="item"
                        >
                          <SlpIcon
                            name="check"
                            class="bullet"
                            variant="product"
                            alt="Check icon"
                            size="sm"
                          />
                          <span
                            class="slp-text-body1"
                            v-html="feature.text"
                          ></span>
                        </li>
                      </ul>
                    </SlpTypography>
                  </div>
                </div>
              </div>
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
      </SlpRow>
      <SlpRow v-if="data.feature" class="feature__wrapper">
        <div class="feature">
          <img
            class="image"
            :src="data.feature.image"
            :alt="data.feature.alt"
          />
          <div class="text">
            <SlpTypography variant="heading4-bold">{{
              data.feature.title
            }}</SlpTypography>
            <SlpTypography
              variant="body1"
              class="slp-mt-24"
              v-html="data.feature.description"
            />
            <div>
              <SlpButton
                class="slp-pl-0 slp-mt-24"
                :href="data.feature.link.href"
                variant="primary"
                :data-ga-name="
                  data.feature.data_ga_name
                    ? data.feature.data_ga_name
                    : 'Learn More'
                "
                :data-ga-location="
                  data.feature.data_ga_location
                    ? data.feature.data_ga_location
                    : 'body'
                "
              >
                <span class="slp-mr-8">{{ data.feature.link.text }}</span>
                <SlpIcon
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </div>
          </div>
        </div>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.solution-value-prop {
  background-color: $color-surface-800;
  padding-top: 96px;
  padding-bottom: $spacing-96;
  position: relative;
  .feature {
    background: $color-surface-800;
    border-radius: 0 4px 100px 0;
    margin-top: $spacing-8;
    display: flex;
    &__wrapper {
      padding-right: $spacing-16;
    }
    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      .image {
        display: none;
      }
    }
    .image {
      min-width: 49%;
    }
    .text {
      display: flex;
      flex-direction: column;
      padding: 40px;
      &:deep(a:hover) {
        text-decoration: underline;
      }
    }
  }
  &.light-background {
    background: $color-primary-300;
    &:after {
      background: $color-primary-300;
    }
  }
  &:after {
    content: '';
    position: absolute;
    width: 200vw;
    height: 100%;
    top: 0;
    left: -50vw;
    z-index: -1;
    background: $color-surface-800;
  }
  .learn-more {
    padding-left: 0;
    margin-top: auto;
  }
  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  h2 {
    font-size: $text-heading-2;
    line-height: $line-height-heading-2;
    font-weight: $font-weight-bold;
  }

  .resources-block {
    //cursor: pointer;
    display: flex;
    position: relative;
    height: 100%;

    &__wrapper {
      display: flex;
      flex-direction: column;
      transition: all 0.3s ease-in-out;
      justify-content: space-between;
      padding: $spacing-32;
      background: $color-primary-300;
      &.light-background {
        background: $color-surface-800;
      }
      flex: 1;
      border-radius: $spacing-4;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-8 $spacing-16 $spacing-8 0;
      }
      @media (max-width: $breakpoint-md) {
        margin: $spacing-8 0;
      }

      // This creates the rounded corner hover effect if card is clickable
      //&:hover {
      //  background: $color-surface-900;
      //  border-bottom-right-radius: 100px;
      //  box-shadow: 10px 10px 40px 10px #d1d0d3;
      //}
    }

    &__header {
      width: 100%;
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }

    &__category {
      margin-bottom: $spacing-24;

      img {
        max-width: 30px;
        filter: grayscale(100%);
        -webkit-filter: grayscale(100%);
      }

      p {
        margin-left: $spacing-16;
        text-transform: uppercase;
        font-weight: $font-weight-bold;
        letter-spacing: 1px;
      }
    }

    &__image {
      max-width: 100%;
    }

    &__link {
      color: $color-text-300;
      padding-left: 0;
    }

    &__title {
      margin-bottom: $spacing-16;
      font-size: $text-heading-4;
      font-weight: $font-weight-bold;
    }

    &__description {
      margin-bottom: $spacing-16;
      &:deep(a:hover) {
        text-decoration: underline;
      }
    }

    &__list {
      margin-bottom: $spacing-16;

      .item {
        margin-bottom: $spacing-16;
        display: flex;
      }

      .bullet {
        margin-right: $spacing-8;
      }
    }

    &__content-top {
      display: flex;
      flex-basis: 100%;
      flex-direction: column;
      p,
      h3,
      li {
        color: $color-text-300;
      }

      :last-child {
        margin-bottom: 0;
      }
    }
    &__col {
      width: 100%;
    }
  }
}
</style>
